//Dzieki temu naglowkowi mozemy korzystac ze zmiennych typu uint32_t itp.
#include <stdint.h>

#include "system.h"
#include "sys/alt_stdio.h"
#include "sys/alt_sys_wrappers.h"
#include "altera_avalon_pio_regs.h"
#include "altera_avalon_timer_regs.h"

#include "sys/alt_irq.h"

#include "7SEG.h"

volatile uint16_t counter = 0;

void timer0Interrupt(void* context){
	IOWR_ALTERA_AVALON_TIMER_STATUS(TIMER0_BASE, 0);
	refreshDisplay();
	
	static uint16_t msCounter = 0;
	uint16_t state = IORD_ALTERA_AVALON_PIO_DATA(SW_BASE);
	if(state != 0b111){
		if(msCounter < 50){
			msCounter++;
		}else if(msCounter == 50){
			counter++;
			intDisplayDec(counter);
			msCounter++;
		}
	}else{
		msCounter = 0;
	}
}


int main()
{ 
	alt_putstr("Hello from Nios II!\n");

	alt_ic_isr_register(TIMER0_IRQ_INTERRUPT_CONTROLLER_ID, TIMER0_IRQ, timer0Interrupt, NULL, NULL);

	IOWR_ALTERA_AVALON_TIMER_CONTROL(TIMER0_BASE, ALTERA_AVALON_TIMER_CONTROL_START_MSK |
		ALTERA_AVALON_TIMER_CONTROL_CONT_MSK | ALTERA_AVALON_TIMER_CONTROL_ITO_MSK );

	intDisplayDec(0);

	/* Event loop never exits. */
	while (1){

	}

	return 0;
}
